String.prototype.replaceAll = function (find, replace) {
    var str = this;
    return str.replace(new RegExp(find.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&'), 'g'), replace);
}

function ShowAlert(err) {
    dhtmlx.alert({ title: "Info", type: "alert", text: err });
}

function ShowWarning(err) {
    dhtmlx.alert({ title: "Attention", type: "alert-warning", text: err });
}

function ShowError(err) {
    if (navigator.appVersion.indexOf("MSIE 7.") != -1) {
        alert(err);
    }
    else {
        dhtmlx.alert({ title: "Erreur", type: "alert-error", text: err });
    }
}

function ShowConfirm(err) {
    dhtmlx.confirm({ title: "Info", type: "confirm", text: err });
}

function ShowConfirmWarning(err) {
    dhtmlx.confirm({ title: "Attention", type: "confirm-warning", text: err });
}

function ShowConfirmError(err) {
    dhtmlx.confirm({ title: "Erreur", type: "confirm-error", text: err });
}

function ShowQuestion(txtTitle, txtText, txtOk, txtCancel, callOK, callCancel) {
    dhtmlx.confirm({ title: txtTitle, type: "confirm", text: txtText, ok: txtOk, cancel: txtCancel, callback: function (ret) {
        if (ret) {
            eval(callOK);
        }
        else {
            eval(callCancel);
        }
    }
    });
}

function ShowMessage(err) {
    dhtmlx.message({ text: err });
}

function getStackTrace() {
    var f = arguments.callee;
    var ret = [];
    var item = {};
    var iter = 0;

    while (f = f.caller) {
        // Initialize
        var callerFunction = 'Main';
        if (f.caller !== null) {
            var callerFunction = f.caller.toString().match(/function ([^\(]+)/)[1];
        }

        item = {
            name: f.name || null,
            args: [], // Empty array = no arguments passed
            //callback: f	  
            callback: callerFunction
        };

        // Function arguments
        if (f.arguments) {
            for (iter = 0; iter < f.arguments.length; iter++) {
                item.args[iter] = f.arguments[iter];
            }
        } else {
            item.args = null; // null = argument listing not supported
        }

        ret.push(item);
    }
    return ret;
}

function ShowJsError(e) {
    var message = '';
    callerFunction = 'Main';
    if (arguments.callee.caller !== null) {
        var callerFunction = arguments.callee.caller.toString().match(/function ([^\(]+)/)[1];
    }
    //var callerFunction = (arguments.callee.caller.toString().match(/function ([^\(]+)/) === null) ? 'Document Object Model': arguments.callee.caller.toString().match(/function ([^\(]+)/)[1], arguments.callee.toString().match(/function ([^\(]+)/)[1]);
    message += '<b>Function:</b> ' + callerFunction + '<br>';
    for (var i in e) {
        message += '<b>' + i + '</b>: ' + e[i] + '<br>';
    }

    message += '<br><u>Stack trace:</u><br>';
    var stack = getStackTrace();
    for (var i in stack) {
        item = stack[i];
        for (var j in item) {
            message += '   ' + i + ' <b><i>' + j + ':</i></b> ' + item[j] + '<br>';
        }
        message += '<br>';
    }
    message = '<div style="text-align:left;"><span style="width:800px;">' + message + '</span></div>';
    ShowError(message);
}